module ccm_merge

    public :: merge_it
    interface merge_it 
       module procedure merge_in
       module procedure merge_sp
       module procedure merge_dp
       module procedure merge_comp
       module procedure merge_dpcomp
       module procedure merge_logical
!       module procedure merge_qp                                        !qp
!       module procedure merge_qpcomp                                    !qp
    end interface
    
    public ccm_operations
    interface ccm_operations
        module procedure list_in
        module procedure list_sp
        module procedure list_dp
        module procedure list_comp
        module procedure list_dpcomp
        module procedure list_logical
!        module procedure list_qp                                        !qp
!        module procedure list_qpcomp                                    !qp
    end interface

contains
        subroutine list_in(x,list,n)
            use ccm_numz
            integer(def_int) :: x
            character(len=4) :: list(:)
            integer :: n
            n=7
            list(1:n)=(/"+   ", "min ",  "max ",  "*   "  , "and ",  "or  " , "xor "/)
        end subroutine
        
        subroutine list_sp(x,list,n)
            use ccm_numz
            real(b4) :: x
            character(len=4) :: list(:)
            integer :: n
            n=4
            list(1:n)=(/"+   ", "min ",  "max ",  "*   " /)
        end subroutine
        
        subroutine list_dp(x,list,n)
            use ccm_numz
            real(b8) :: x
            character(len=4) :: list(:)
            integer :: n
            n=4
            list(1:n)=(/"+   ", "min ",  "max ",  "*   "/)
        end subroutine
        
        subroutine list_comp(x,list,n)
            use ccm_numz
            complex(c4) :: x
            character(len=4) :: list(:)
            integer :: n
            n=2
            list(1:n)=(/"+   ", "*   "/)
        end subroutine
        
        subroutine list_dpcomp(x,list,n)
            use ccm_numz
            complex(c8) :: x
            character(len=4) :: list(:)
            n=2
            list(1:n)=(/"+   ", "*   "/)
        end subroutine
        
        subroutine list_logical(x,list,n)
            use ccm_numz
            logical :: x
            character(len=4) :: list(:)
            integer :: n
            n=3
            list(1:n)=(/"and ",  "or  " , "xor "/)
        end subroutine
        

        subroutine get_oper(oper,intype,mpi_oper,my_oper,illegal)
            use ccm_numz
            use ccm_error_mod
            implicit none
            character (len= *),intent (in) :: oper
            integer , intent(in) :: intype
            integer , intent(out) :: mpi_oper
            character (len= *),intent (out) :: my_oper
            logical, intent(out) :: illegal
            illegal=.false.
                if (intype .eq. myreal   .or. &
                    intype .eq. mydouble .or. &
                    intype .eq. myquad           )then
                    select case (oper)
                    case ("+","sum","SUM")
                                    !mpi_oper=MPI_SUM
                                    my_oper="+"
                    case ("min","MIN")
                                    !mpi_oper=MPI_MIN
                                    my_oper="min"
                    case ("max","MAX")
                                    !mpi_oper=MPI_MAX
                                    my_oper="max"
                    case ("*","prod","PROD")
                                    !mpi_oper=MPI_PROD
                                    my_oper="*"
                    case default
                                    my_oper="unde"
                                    mpi_oper=-1
                                    illegal=.true.
                    end select
                endif
                if (intype .eq. myint)then
                    select case (oper)
                    case ("+","sum","SUM")
                                    !mpi_oper=MPI_SUM
                                    my_oper="+"
                    case ("min","MIN")
                                    !mpi_oper=MPI_MIN
                                    my_oper="min"
                    case ("max","MAX")
                                    !mpi_oper=MPI_MAX
                                    my_oper="max"
                    case ("*","prod","PROD")
                                    !mpi_oper=MPI_PROD
                                    my_oper="*"
                    case ("and","AND")
                                    !mpi_oper=MPI_BAND
                                    my_oper="and"
                    case ("or","OR")
                                    !mpi_oper=MPI_BOR
                                    my_oper="or"
                    case ("xor","XOR")
                                    !mpi_oper=MPI_BXOR
                                    my_oper="xor"
                    case default
                                    my_oper="unde"
                                    mpi_oper=-1
                                    illegal=.true.
                    end select 
                endif
                if (intype .eq. mycomp   .or. &
                    intype .eq. mydpcomp .or. &
                    intype .eq. myqpcomp        )then
                    select case (oper)
                    case ("+","sum","SUM")
                                    !mpi_oper=MPI_SUM
                                    my_oper="+"
                    case ("*","prod","PROD")
                                    !mpi_oper=MPI_PROD
                                    my_oper="*"
                    case default
                                    my_oper="unde"
                                    mpi_oper=-1
                                    illegal=.true.
                    end select 
                endif
                if (intype .eq. mylogical)then
                    select case (oper)
                    case ("and","AND")
                                    !mpi_oper=MPI_LAND
                                    my_oper="and"
                    case ("or","OR")
                                    !mpi_oper=MPI_LOR
                                    my_oper="or"
                    case ("xor","XOR")
                                    !mpi_oper=MPI_LXOR
                                    my_oper="xor"
                    case default
                                    my_oper="unde"
                                    mpi_oper=-1
                                    illegal=.true.
                    end select 
                endif
        end subroutine get_oper
    subroutine merge_in(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_in
    !       subroutine merge2_in(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           integer, intent (in):: d1(*)
    !           integer, intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer , intent(in) :: n
        integer , intent(in) :: input(:)
        integer , intent (inout):: output(:)
        integer , intent(in) :: root
        integer , intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        integer , allocatable:: rec(:)
        integer , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer :: p,active,rank,i
        integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.
    !
        AN_MPI_TYPE = myint
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_in(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_in(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_in
    
    subroutine merge2_in(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        integer, intent (in):: d1(*)
        integer, intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("+")
                !write(*,*)"doing +"
                d2(1:n)=d1(1:n)+d2(1:n)
            case ("min")
                !write(*,*)"doing min"
                d2(1:n)=min(d1(1:n),d2(1:n))
            case ("max")
                !write(*,*)"doing max"
                d2(1:n)=max(d1(1:n),d2(1:n))
            case ("*")
                !write(*,*)"doing *"
                d2(1:n)=d1(1:n)*d2(1:n)
            case ("and")
                !write(*,*)"doing and"
                d2(1:n)=iand(d1(1:n),d2(1:n))
            case ("or")
                !write(*,*)"doing or"
                d2(1:n)=ior(d1(1:n),d2(1:n))
            case ("xor")
                !write(*,*)"doing or"
                d2(1:n)=ieor(d1(1:n),d2(1:n))
            case default
                write(*,*)"error in merge2_in oper = ",oper
        end select 
    end subroutine merge2_in
    subroutine merge_sp(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_sp
    !       subroutine merge2_sp(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           real(b4), intent (in):: d1(*)
    !           real(b4), intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer, intent(in) :: n
        real(b4), intent(in) :: input(n)
        real(b4), intent (inout):: output(n)
        integer, intent(in) :: root
        integer, intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        real(b4) , allocatable:: rec(:)
        real(b4) , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer p,active,rank,i
        integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.
    !
        AN_MPI_TYPE = myreal
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_sp(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_sp(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_sp
    
    subroutine merge2_sp(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        real(b4), intent (in):: d1(*)
        real(b4), intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("+")
                !write(*,*)"doing +"
                d2(1:n)=d1(1:n)+d2(1:n)
            case ("min")
                !write(*,*)"doing min"
                d2(1:n)=min(d1(1:n),d2(1:n))
            case ("max")
                !write(*,*)"doing max"
                d2(1:n)=max(d1(1:n),d2(1:n))
            case ("*")
                !write(*,*)"doing *"
                d2(1:n)=d1(1:n)*d2(1:n)
            case default
                write(*,*)"error in merge2_sp oper = ",oper
        end select 
    end subroutine merge2_sp

    subroutine merge_dp(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_dp
    !       subroutine merge2_dp(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           real(b8), intent (in):: d1(*)
    !           real(b8), intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer, intent(in) :: n
        real(b8), intent(in) :: input(n)
        real(b8), intent (inout):: output(n)
        integer, intent(in) :: root
        integer, intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        real(b8) , allocatable:: rec(:)
        real(b8) , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer :: p,active,rank,i
        integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.
    !
        AN_MPI_TYPE = mydouble
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_dp(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_dp(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_dp
    
    subroutine merge2_dp(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        real(b8), intent (in):: d1(*)
        real(b8), intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("+")
                !write(*,*)"doing +"
                d2(1:n)=d1(1:n)+d2(1:n)
            case ("min")
                !write(*,*)"doing min"
                d2(1:n)=min(d1(1:n),d2(1:n))
            case ("max")
                !write(*,*)"doing max"
                d2(1:n)=max(d1(1:n),d2(1:n))
            case ("*")
                !write(*,*)"doing *"
                d2(1:n)=d1(1:n)*d2(1:n)
            case default
                write(*,*)"error in merge2_dp oper = ",oper
        end select 
    end subroutine merge2_dp
    
    subroutine merge_comp(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_complex
    !       subroutine merge2_complex(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           complex(c4), intent (in):: d1(*)
    !           complex(c4), intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer, intent(in) :: n
        complex(c4), intent(in) :: input(n)
        complex(c4), intent (inout):: output(n)
        integer, intent(in) :: root
        integer, intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        complex(c4) , allocatable:: rec(:)
        complex(c4) , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer p,active,rank,i
        integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.
    !
        AN_MPI_TYPE = mycomp
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_complex(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_complex(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_comp
    
    subroutine merge2_complex(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        complex(c4), intent (in):: d1(*)
        complex(c4), intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("+")
                !write(*,*)"doing +"
                d2(1:n)=d1(1:n)+d2(1:n)
            case ("*")
                !write(*,*)"doing *"
                d2(1:n)=d1(1:n)*d2(1:n)
            case default
                write(*,*)"error in merge2_complex oper = ",oper
        end select 
    end subroutine merge2_complex


    subroutine merge_dpcomp(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_dpcomp
    !       subroutine merge2_dpcomp(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           complex(c8), intent (in):: d1(*)
    !           complex(c8), intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer, intent(in) :: n
        complex(c8), intent(in) :: input(n)
        complex(c8), intent (inout):: output(n)
        integer, intent(in) :: root
        integer, intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        complex(c8) , allocatable:: rec(:)
        complex(c8) , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer p,active,rank,i
		integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.    
    !
        AN_MPI_TYPE = mydpcomp
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_dpcomp(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_dpcomp(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_dpcomp
    
    subroutine merge2_dpcomp(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        complex(c8), intent (in):: d1(*)
        complex(c8), intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("+")
                !write(*,*)"doing +"
                d2(1:n)=d1(1:n)+d2(1:n)
            case ("*")
                !write(*,*)"doing *"
                d2(1:n)=d1(1:n)*d2(1:n)
            case default
                write(*,*)"error in merge2_dpcomp oper = ",oper
        end select 
    end subroutine merge2_dpcomp

    subroutine merge_logical(input,n,output,oper,root,THETAG,THECOM,ierr)
            use ccm_numz
            use ccm_error_mod
            use ccm_sndrcv
        implicit none
        
    !   interface merge2_logical
    !       subroutine merge2_logical(d1,n,d2,oper)
    !               use ccm_numz
    !           integer :: n,m
    !           logical, intent (in):: d1(*)
    !           logical, intent (inout):: d2(*)
    !           character (len=*),intent (in) :: oper
    !       end subroutine
    !   end interface
        
        integer, intent(in) :: n
        logical, intent(in) :: input(n)
        logical, intent (inout):: output(n)
        integer, intent(in) :: root
        integer, intent(inout) :: ierr
        character (len=*),intent (in) :: oper
        integer :: THETAG,THECOM,NTAG,it
    !   
        logical , allocatable:: rec(:)
        logical , allocatable :: the_data(:)
        integer :: AN_MPI_TYPE
        integer p,active,rank,i
		integer :: status(MPI_STATUS_SIZE)
        logical :: did_get
        did_get=.false.
    !
        AN_MPI_TYPE = mpi_logical
!        call MPI_COMM_RANK(THECOM,rank,mpi_err)
!        call MPI_COMM_SIZE(THECOM, p, mpi_err )
        rank=myid
        p=numnodes
        if(root .ne. 0)then
		rank=rank-root
		if(rank .lt. 0)rank=(p+rank)
	endif
	active=1
	do while (2*active < p)
		active=active*2
	enddo
	if(rank .ge. active)then
		! send(input,rank-active)
		it=rank-active+root
		if(it .ge. p)it=p-it
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input
		call ccm_send(input,n,it)
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		return
	endif
	allocate(the_data(n))
	!   the_data=input
	if(rank + active  .lt. p)then
		! rec(new_data,rank+active)
		if(.not.(allocated(rec))) allocate(rec(n))
		it=rank+active+root
		if(it .ge. p)it=p-it
		call ccm_recv(rec,n,it)
		if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec
		did_get=.true.
		if(ierr .ne. 0)then
			write(err_str1,"(""low level communication error:"",i5)")ierr
			call ccm_fatal("reduce",AN_MPI_TYPE)
		endif
		! the_data=the_data+new_data
		call merge2_logical(input,n,rec,oper)
		the_data=rec
	endif
	do while (active .gt. 1)
		active=active/2
		if(rank .ge. active) then
			! send(the_data,rank-active)
			it=rank-active+root
			if(it .ge. p)it=p-it
			if(.not. did_get)the_data(1:n)=input(1:n)
			if(iand(do_tests,ccm_internal) .ne. 0) &
				write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data
			call ccm_send(the_data,n,it)
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			if(allocated(the_data))deallocate(the_data)
			if(allocated(rec))deallocate(rec)
			return
		else
		! recv(new_data,rank+active)
			if(.not.(allocated(rec))) allocate(rec(n))
			it=rank+active+root
			if(it .ge. p)it=p-it
			call ccm_recv(rec,n,it)
			if(iand(do_tests,ccm_internal) .ne. 0) &
			write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec
			if(ierr .ne. 0)then
				write(err_str1,"(""low level communication error:"",i5)")ierr
				call ccm_fatal("reduce",AN_MPI_TYPE)
			endif
			! the_data=the_data+new_data
			if(.not. did_get)the_data(1:n)=input(1:n)
			call merge2_logical(rec,n,the_data,oper)
			did_get=.true.
		endif
	enddo

        if(myid .eq. root)then
            do i=1,n
                output(i)=the_data(i)
            enddo
        endif
        if(allocated(the_data))deallocate(the_data)
        if(allocated(rec))deallocate(rec)
        return
    end subroutine merge_logical
    
    subroutine merge2_logical(d1,n,d2,oper)
            use ccm_numz
            use ccm_error_mod
        integer, intent (in) :: n
        logical, intent (in):: d1(*)
        logical, intent (inout):: d2(*)
        character (len=*),intent (in) :: oper
        integer ::  i
        select case (oper)
            case ("and")
                d2(1:n)=d1(1:n) .and. d2(1:n)
            case ("or")
                d2(1:n)=d1(1:n) .or.  d2(1:n)
            case ("xor")
                d2(1:n)=d1(1:n) .neqv. d2(1:n)
            case default
                write(*,*)"error in merge2_logical oper = ",oper
        end select 
    end subroutine merge2_logical
!        subroutine list_qpcomp(x,list,n)                                      !qp
!            use ccm_numz                                                      !qp
!            complex(c16) :: x                                                  !qp
!            character(len=4) :: list(:)                                       !qp
!            n=2                                                               !qp
!            list(1:n)=(/"+   ", "*   "/)                                      !qp
!        end subroutine                                                        !qp       
!subroutine merge_qpcomp(input,n,output,oper,root,THETAG,THECOM,ierr)          !qp
!  use ccm_numz                                                                !qp
!  use ccm_error_mod                                                           !qp
!  use ccm_sndrcv                                                              !qp
!  implicit none                                                               !qp
!  integer, intent(in) :: n                                                    !qp
!  complex(c16), intent(in) :: input(n)                                        !qp
!  complex(c16), intent (inout):: output(n)                                    !qp
!  integer, intent(in) :: root                                                 !qp
!  integer, intent(inout) :: ierr                                              !qp
!  character (len=*),intent (in) :: oper                                       !qp
!  integer :: THETAG,THECOM,NTAG,it                                            !qp
!  complex(c16) , allocatable:: rec(:)                                         !qp
!  complex(c16) , allocatable :: the_data(:)                                   !qp
!  integer :: AN_MPI_TYPE                                                      !qp
!  integer p,active,rank,i                                                     !qp
!  integer :: status(MPI_STATUS_SIZE)                                          !qp
!  logical :: did_get                                                          !qp
!  did_get=.false.                                                             !qp
!  AN_MPI_TYPE = myqpcomp                                                      !qp
!  rank=myid                                                                   !qp
!  p=numnodes                                                                  !qp
!  if(root .ne. 0)then                                                         !qp
!    rank=rank-root                                                            !qp
!    if(rank .lt. 0)rank=(p+rank)                                              !qp
!  endif                                                                       !qp
!  active=1                                                                    !qp
!  do while (2*active < p)                                                     !qp
!    active=active*2                                                           !qp
!  enddo                                                                       !qp
!  if(rank .ge. active)then                                                    !qp
!    it=rank-active+root                                                       !qp
!    if(it .ge. p)it=p-it                                                      !qp
!    if(iand(do_tests,ccm_internal) .ne. 0) &                                  !qp
!    write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input   !qp
!    call ccm_send(input,n,it)                                                 !qp
!    if(ierr .ne. 0)then                                                       !qp
!      write(err_str1,"(""low level communication error:"",i5)")ierr           !qp
!      call ccm_fatal("reduce",AN_MPI_TYPE)                                    !qp
!    endif                                                                     !qp
!    return                                                                    !qp
!  endif                                                                       !qp
!  allocate(the_data(n))                                                       !qp
!  if(rank + active  .lt. p)then                                               !qp
!    if(.not.(allocated(rec))) allocate(rec(n))                                !qp
!    it=rank+active+root                                                       !qp
!    if(it .ge. p)it=p-it                                                      !qp
!    call ccm_recv(rec,n,it)                                                   !qp
!    if(iand(do_tests,ccm_internal) .ne. 0) &                                  !qp
!      write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec   !qp
!    did_get=.true.                                                            !qp
!    if(ierr .ne. 0)then                                                       !qp
!      write(err_str1,"(""low level communication error:"",i5)")ierr           !qp
!      call ccm_fatal("reduce",AN_MPI_TYPE)                                    !qp
!    endif                                                                     !qp
!    call merge2_qpcomp(input,n,rec,oper)                                      !qp
!    the_data=rec                                                              !qp
!  endif                                                                       !qp
!  do while (active .gt. 1)                                                    !qp
!    active=active/2                                                           !qp
!    if(rank .ge. active) then                                                 !qp
!      it=rank-active+root                                                     !qp
!      if(it .ge. p)it=p-it                                                    !qp
!      if(.not. did_get)the_data(1:n)=input(1:n)                               !qp
!      if(iand(do_tests,ccm_internal) .ne. 0) &                                !qp
!        write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data             !qp
!      call ccm_send(the_data,n,it)                                            !qp
!      if(ierr .ne. 0)then                                                     !qp
!        write(err_str1,"(""low level communication error:"",i5)")ierr         !qp
!        call ccm_fatal("reduce",AN_MPI_TYPE)                                  !qp
!      endif                                                                   !qp
!      if(allocated(the_data))deallocate(the_data)                             !qp
!      if(allocated(rec))deallocate(rec)                                       !qp
!      return                                                                  !qp
!    else                                                                      !qp
!      if(.not.(allocated(rec))) allocate(rec(n))                              !qp
!      it=rank+active+root                                                     !qp
!      if(it .ge. p)it=p-it                                                    !qp
!      call ccm_recv(rec,n,it)                                                 !qp
!      if(iand(do_tests,ccm_internal) .ne. 0) &                                !qp
!      write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec                  !qp
!      if(ierr .ne. 0)then                                                     !qp
!        write(err_str1,"(""low level communication error:"",i5)")ierr         !qp
!        call ccm_fatal("reduce",AN_MPI_TYPE)                                  !qp
!      endif                                                                   !qp
!      if(.not. did_get)the_data(1:n)=input(1:n)                               !qp
!      call merge2_qpcomp(rec,n,the_data,oper)                                 !qp
!      did_get=.true.                                                          !qp
!    endif                                                                     !qp
!  enddo                                                                       !qp
!  if(myid .eq. root)then                                                      !qp
!    do i=1,n                                                                  !qp
!      output(i)=the_data(i)                                                   !qp
!    enddo                                                                     !qp
!  endif                                                                       !qp
!  if(allocated(the_data))deallocate(the_data)                                 !qp
!  if(allocated(rec))deallocate(rec)                                           !qp
!  return                                                                      !qp
!end subroutine merge_qpcomp                                                   !qp
!subroutine merge2_qpcomp(d1,n,d2,oper)                                        !qp
!  use ccm_numz                                                                !qp
!  use ccm_error_mod                                                           !qp
!  integer, intent (in) :: n                                                   !qp
!  complex(c16), intent (in):: d1(*)                                           !qp
!  complex(c16), intent (inout):: d2(*)                                        !qp
!  character (len=*),intent (in) :: oper                                       !qp
!  integer ::  i                                                               !qp
!  select case (oper)                                                          !qp
!    case ("+")                                                                !qp
!      d2(1:n)=d1(1:n)+d2(1:n)                                                 !qp
!    case ("*")                                                                !qp
!      d2(1:n)=d1(1:n)*d2(1:n)                                                 !qp
!    case default                                                              !qp
!      write(*,*)"error in merge2_qpcomp oper = ",oper                         !qp
!  end select                                                                  !qp
!end subroutine merge2_qpcomp                                                  !qp
!        subroutine list_qp(x,list,n)                                          !qp
!            use ccm_numz                                                      !qp
!            real(b16) :: x                                                    !qp
!            character(len=4) :: list(:)                                       !qp
!            integer :: n                                                      !qp
!            n=4                                                               !qp
!            list(1:n)=(/"+   ", "min ",  "max ",  "*   "/)                    !qp
!        end subroutine                                                        !qp
!subroutine merge_qp(input,n,output,oper,root,THETAG,THECOM,ierr)              !qp
!  use ccm_numz                                                                !qp
!  use ccm_error_mod                                                           !qp
!  use ccm_sndrcv                                                              !qp
!  implicit none                                                               !qp
!  integer, intent(in) :: n                                                    !qp
!  real(b16), intent(in) :: input(n)                                           !qp
!  real(b16), intent (inout):: output(n)                                       !qp
!  integer, intent(in) :: root                                                 !qp
!  integer, intent(inout) :: ierr                                              !qp
!  character (len=*),intent (in) :: oper                                       !qp
!  integer :: THETAG,THECOM,NTAG,it                                            !qp
!  real(b16) , allocatable:: rec(:)                                            !qp
!  real(b16) , allocatable :: the_data(:)                                      !qp
!  integer :: AN_MPI_TYPE                                                      !qp
!  integer p,active,rank,i                                                     !qp
!  integer :: status(MPI_STATUS_SIZE)                                          !qp
!  logical :: did_get                                                          !qp
!  did_get=.false.                                                             !qp
!  AN_MPI_TYPE = myquad                                                        !qp
!  rank=myid                                                                   !qp
!  p=numnodes                                                                  !qp
!  if(root .ne. 0)then                                                         !qp
!    rank=rank-root                                                            !qp
!    if(rank .lt. 0)rank=(p+rank)                                              !qp
!  endif                                                                       !qp
!  active=1                                                                    !qp
!  do while (2*active < p)                                                     !qp
!    active=active*2                                                           !qp
!  enddo                                                                       !qp
!  if(rank .ge. active)then                                                    !qp
!    it=rank-active+root                                                       !qp
!    if(it .ge. p)it=p-it                                                      !qp
!    if(iand(do_tests,ccm_internal) .ne. 0) &                                  !qp
!    write(*,*)"s 1 myid=",myid," rank= ",rank," to ",it," n= ",n,"x=",input   !qp
!    call ccm_send(input,n,it)                                                 !qp
!    if(ierr .ne. 0)then                                                       !qp
!      write(err_str1,"(""low level communication error:"",i5)")ierr           !qp
!      call ccm_fatal("reduce",AN_MPI_TYPE)                                    !qp
!    endif                                                                     !qp
!    return                                                                    !qp
!  endif                                                                       !qp
!  allocate(the_data(n))                                                       !qp
!  if(rank + active  .lt. p)then                                               !qp
!    if(.not.(allocated(rec))) allocate(rec(n))                                !qp
!    it=rank+active+root                                                       !qp
!    if(it .ge. p)it=p-it                                                      !qp
!    call ccm_recv(rec,n,it)                                                   !qp
!    if(iand(do_tests,ccm_internal) .ne. 0) &                                  !qp
!      write(*,*)"r 2 myid=",myid," rank=",rank," from ",it," n=",n,"x=",rec   !qp
!    did_get=.true.                                                            !qp
!    if(ierr .ne. 0)then                                                       !qp
!      write(err_str1,"(""low level communication error:"",i5)")ierr           !qp
!      call ccm_fatal("reduce",AN_MPI_TYPE)                                    !qp
!    endif                                                                     !qp
!    call merge2_qp(input,n,rec,oper)                                          !qp
!    the_data=rec                                                              !qp
!  endif                                                                       !qp
!  do while (active .gt. 1)                                                    !qp
!    active=active/2                                                           !qp
!    if(rank .ge. active) then                                                 !qp
!      it=rank-active+root                                                     !qp
!      if(it .ge. p)it=p-it                                                    !qp
!      if(.not. did_get)the_data(1:n)=input(1:n)                               !qp
!      if(iand(do_tests,ccm_internal) .ne. 0) &                                !qp
!        write(*,*)"s 3 myid=",myid,rank," to ",it,n,"x=",the_data             !qp
!      call ccm_send(the_data,n,it)                                            !qp
!      if(ierr .ne. 0)then                                                     !qp
!        write(err_str1,"(""low level communication error:"",i5)")ierr         !qp
!        call ccm_fatal("reduce",AN_MPI_TYPE)                                  !qp
!      endif                                                                   !qp
!      if(allocated(the_data))deallocate(the_data)                             !qp
!      if(allocated(rec))deallocate(rec)                                       !qp
!      return                                                                  !qp
!    else                                                                      !qp
!      if(.not.(allocated(rec))) allocate(rec(n))                              !qp
!      it=rank+active+root                                                     !qp
!      if(it .ge. p)it=p-it                                                    !qp
!      call ccm_recv(rec,n,it)                                                 !qp
!      if(iand(do_tests,ccm_internal) .ne. 0) &                                !qp
!      write(*,*)"r 4 myid=",myid,rank," from ",it,n,"x=",rec                  !qp
!      if(ierr .ne. 0)then                                                     !qp
!        write(err_str1,"(""low level communication error:"",i5)")ierr         !qp
!        call ccm_fatal("reduce",AN_MPI_TYPE)                                  !qp
!      endif                                                                   !qp
!      if(.not. did_get)the_data(1:n)=input(1:n)                               !qp
!      call merge2_qp(rec,n,the_data,oper)                                     !qp
!      did_get=.true.                                                          !qp
!    endif                                                                     !qp
!  enddo                                                                       !qp
!  if(myid .eq. root)then                                                      !qp
!    do i=1,n                                                                  !qp
!      output(i)=the_data(i)                                                   !qp
!    enddo                                                                     !qp
!  endif                                                                       !qp
!  if(allocated(the_data))deallocate(the_data)                                 !qp
!  if(allocated(rec))deallocate(rec)                                           !qp
!  return                                                                      !qp
!end subroutine merge_qp                                                       !qp
!subroutine merge2_qp(d1,n,d2,oper)                                            !qp
!  use ccm_numz                                                                !qp
!  use ccm_error_mod                                                           !qp
!  integer, intent (in) :: n                                                   !qp
!  real(b16), intent (in):: d1(*)                                              !qp
!  real(b16), intent (inout):: d2(*)                                           !qp
!  character (len=*),intent (in) :: oper                                       !qp
!  integer ::  i                                                               !qp
!  select case (oper)                                                          !qp
!    case ("+")                                                                !qp
!      d2(1:n)=d1(1:n)+d2(1:n)                                                 !qp
!    case ("*")                                                                !qp
!      d2(1:n)=d1(1:n)*d2(1:n)                                                 !qp
!    case ("min")                                                              !qp
!      d2(1:n)=min(d1(1:n),d2(1:n))                                            !qp
!    case ("max")                                                              !qp
!      d2(1:n)=max(d1(1:n),d2(1:n))                                            !qp
!    case default                                                              !qp
!      write(*,*)"error in merge2_qp oper = ",oper                             !qp
!  end select                                                                  !qp
!end subroutine merge2_qp                                                      !qp
    end module
